# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' OptColumnMapping Class
#'
#' Additional columns can be added to the end of the small molecule table. These column headers MUST start with the prefix “opt_” followed by the {identifier} of the object they reference: assay, study variable, MS run or “global” (if the value relates to all replicates). Column names MUST only contain the following characters: ‘A’-‘Z’, ‘a’-‘z’, ‘0’-‘9’, ‘’, ‘-’, ‘[’, ‘]’, and ‘:’. CV parameter accessions MAY be used for optional columns following the format: opt{identifier}_cv_{accession}_\\{parameter name}. Spaces within the parameter’s name MUST be replaced by ‘_’. 
#'
#' @field identifier 
#' @field param 
#' @field value 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' SMH	SML_ID	…	opt_assay[1]_my_value	…	opt_global_another_value
SML	1	…	My value	…	some other value

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
OptColumnMapping <- R6::R6Class(
  'OptColumnMapping',
  public = list(
    `identifier` = NULL,
    `param` = NULL,
    `value` = NULL,
    initialize = function(`identifier`, `param`, `value`){
      if (!missing(`identifier`)) {
        stopifnot(is.character(`identifier`), length(`identifier`) == 1)
        self$`identifier` <- `identifier`
      }
      if (!missing(`param`)) {
        stopifnot(R6::is.R6(`param`))
        self$`param` <- `param`
      }
      if (!missing(`value`)) {
        stopifnot(is.character(`value`), length(`value`) == 1)
        self$`value` <- `value`
      }
    },
    toJSON = function() {
      OptColumnMappingObject <- list()
      if (!is.null(self$`identifier`)) {
        OptColumnMappingObject[['identifier']] <- self$`identifier`
      }
      if (!is.null(self$`param`)) {
        OptColumnMappingObject[['param']] <- self$`param`$toJSON()
      }
      if (!is.null(self$`value`)) {
        OptColumnMappingObject[['value']] <- self$`value`
      }

      OptColumnMappingObject
    },
    fromJSON = function(OptColumnMappingJson) {
      OptColumnMappingObject <- jsonlite::fromJSON(OptColumnMappingJson, simplifyVector = FALSE)
      if (!is.null(OptColumnMappingObject$`identifier`)) {
        self$`identifier` <- OptColumnMappingObject$`identifier`
      }
      if (!is.null(OptColumnMappingObject$`param`)) {
        `paramObject` <- Parameter$new()
        `paramObject`$fromJSON(jsonlite::toJSON(OptColumnMappingObject$param, auto_unbox = TRUE))
        self$`param` <- `paramObject`
      }
      if (!is.null(OptColumnMappingObject$`value`)) {
        self$`value` <- OptColumnMappingObject$`value`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "identifier": %s,
           "param": %s,
           "value": %s
        }',
        self$`identifier`,
        self$`param`$toJSON(),
        self$`value`
      )
    },
    fromJSONString = function(OptColumnMappingJson) {
      OptColumnMappingObject <- jsonlite::fromJSON(OptColumnMappingJson, simplifyVector = FALSE)
      self$`identifier` <- OptColumnMappingObject$`identifier`
      ParameterObject <- Parameter$new()
      self$`param` <- ParameterObject$fromJSON(jsonlite::toJSON(OptColumnMappingObject$param, auto_unbox = TRUE))
      self$`value` <- OptColumnMappingObject$`value`
    }
  )
)
